package cz.cuni.amis.pogamut.emohawk.examples.emoticonbot;

import SteeringProperties.*;
import cz.cuni.amis.introspection.java.JProp;
import cz.cuni.amis.pogamut.base.agent.impl.AgentId;
import cz.cuni.amis.pogamut.base.agent.navigation.IPathFuture;
import cz.cuni.amis.pogamut.base.utils.guice.AgentScoped;
import cz.cuni.amis.pogamut.base3d.worldview.object.Location;
import cz.cuni.amis.pogamut.emohawk.agent.module.sensomotoric.*;
import cz.cuni.amis.pogamut.emohawk.bot.impl.EmohawkBotController;
import cz.cuni.amis.pogamut.ut2004.agent.module.sensor.AgentInfo;
import cz.cuni.amis.pogamut.ut2004.bot.impl.UT2004Bot;
import cz.cuni.amis.pogamut.ut2004.bot.params.UT2004BotParameters;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbcommands.Initialize;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbcommands.SendMessage;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.*;
import cz.cuni.amis.pogamut.ut2004.communication.parser.UT2004Parser;
import cz.cuni.amis.pogamut.ut2004.utils.UT2004BotRunner;
import cz.cuni.amis.utils.exception.PogamutException;
import java.util.logging.Level;

/**
 * Pogamut's "Hello world!" example showing few extra things such as introspection
 * and various bot-initializing methods.
 * <p><p>
 * First, try to run the bot and kill it... than uncomment the line inside {@link EmohawkEmptyBot#botKilled(BotKilled)} 
 * and run the bot again kill it to see the difference. 
 *
 * @author Michal Bida aka Knight
 * @author Rudolf Kadlec aka ik
 * @author Jakub Gemrot aka Jimmy
 */
@AgentScoped
public class EmoticonBot extends EmohawkBotController {
    
//    enum Relation { Unknown, InLove, Afraid, PissedOf };
    enum Behaviour { Born, TurningAround, GoToMeeting, SpotAPerson, InLove, Afraid, Aggresive}

    @JProp    
    static int initialized = 0;
    
    @JProp
    public int closeRange = 500;
    
    @JProp 
    public int farRange = 1000;
    Behaviour behaviour = Behaviour.Born;
    
    // this Target Location should be near Sphere
    @JProp 
    public int LocX = 6013;
    @JProp 
    public int LocY = 1370;
    @JProp 
    public int LocZ = -3440;
    
    Location cinema = new Location(-1157,-7964,-3174);    
    Location target = new Location(LocX, LocY, LocZ);

    
    Location Start1 = target;
//    Location Start2 = new Location(LocX + 200, LocY+ 200, LocZ); // near target but can be spawned by person standing on the target
    Location Start2 = new Location(5163, -2443, -3440); // ner the bowl
    
//    Location Start1 = new Location(5418,5000,-3440);
//    Location Start2 = new Location(6000, 2000, -3440);
//    

    EmoticonType afraid = EmoticonType.SCARED_SMILEY_171;
    EmoticonType inLove = EmoticonType.LOVERS_248;
    EmoticonType aggresive =EmoticonType.FUCK_OFF_175;
    Emoticon currentEmo = null;
    
//    // for more players here should be HasMap with UnrealID
//    Relation relation = Relation.Unknown;
    
//    Boolean followPlayer = false;
//    Boolean followingPlayer = false;
//    Boolean isClose = false;
    Boolean change = true;
    
    
    /**
     * Initialize all necessary variables here, before the bot actually receives anything
     * from the environment.
     */
    @Override
    public void prepareBot(UT2004Bot bot) { }    
    
    /**
     * Here we can modify initializing command for our bot, e.g., sets its name or skin.
     * @return instance of {@link Initialize}
     */
    @Override 
    public Initialize getInitializeCommand() {
        Initialize mybot = new Initialize();        
        if(initialized++ == 0) {
            mybot.setClassName(CharacterType.BARBARA.getUE2Class()).setName("Barbara"+ Double.toString(random.nextDouble()));
//            mybot.setClassName(CharacterType.THOMAS.getUE2Class()).setName("Thomas1"+Double.toString(random.nextDouble()));
            mybot.setLocation(Start1);            
        } 
        else {
            mybot.setClassName(CharacterType.THOMAS.getUE2Class()).setName("Thomas"+Double.toString(random.nextDouble()));
            mybot.setLocation(Start2);            
        }
                
        
        return mybot;        
    }
    
    /**
     * Handshake with GameBots2004 is over - bot has information about the map in its world view.
     * Many agent modules are usable since this method is called.
     * @param gameInfo informaton about the game type
     * @param config information about configuration
     * @param init information about configuration
     */
    @Override
    public void botInitialized(GameInfo gameInfo, ConfigChange currentConfig, InitedMessage init) {
        ((UT2004Parser)bot.getEventBus().getComponent(UT2004Parser.COMPONENT_ID)).getLog().setLevel(Level.OFF);
        bot.getLogger().getCategory("Yylex").setLevel(Level.OFF);
    }

    /**
     * The bot is initilized in the environment - a physical representation of the bot is present in the game.
     * @param gameInfo informaton about the game type
     * @param config information about configuration
     * @param init information about configuration
     * @param self information about the agent
     */
    @Override
    public void botFirstSpawn(GameInfo gameInfo, ConfigChange config, InitedMessage init, Self self) {
        // Display a welcome message in the game engine
    	// right in the time when the bot appears in the environment, i.e., his body has just been spawned 
    	// into the UT2004 for the first time.
        comm.sendGlobalTextMessage("Hello world! I am alive!");
        
        // alternatively, you may use getAct() method for issuing arbitrary {@link CommandMessage} for the bot's body
        // inside UT2004
        getAct().act(new SendMessage().setGlobal(true).setText(
                "Hi, I am " + this.getBot().getParams().getAgentId().getName().getFlag()));
    }
    
    /**
     * This method is called only once right before actual logic() method is called for the first time.
     */
    @Override
    public void beforeFirstLogic() {         
        // we are computing paths so it would be nice to end at the navpoint
        target = navigation.getNearestNavPoint(target).getLocation();
        cinema = navigation.getNearestNavPoint(cinema).getLocation();        
        steering.startNavigation();        
    }

    Boolean setBehaviour (Behaviour b) {
        Boolean r = false;
        if (behaviour != b )
            r = true;
        behaviour = b;
        return r;
    }
    
    /**
     * Main method that controls the bot - makes decisions what to do next.
     * It is called iteratively by Pogamut engine every time a synchronous batch
     * from the environment is received. This is usually 4 times per second - it
     * is affected by visionTime variable, that can be adjusted in GameBots ini file in
     * UT2004/System folder.
     *
     * @throws cz.cuni.amis.pogamut.base.exceptions.PogamutException
     */
    @Override
    public void logic() throws PogamutException {
        String msg = "Debug";
        AnimType anim = AnimType.WALK_BACK; // debugging shoud not be ever displayed
        
        // We have changed behaviour in this step
        change = false;
        
        // I would fell in Love the default is that I follow the other one
        Boolean loveLeader = false;
        
        // SENSES 
        Player p = players.getNearestVisiblePlayer();                
        
        // we see the player
         if( p != null) {
            if(this.info.getDistance(p.getLocation()) < closeRange  )  {            
                // Another level - if we are not already meeting somebody start meeting and feeling sthing
                if(behaviour != Behaviour.Afraid && behaviour != Behaviour.InLove && behaviour != Behaviour.Aggresive) {                
                    // If I do not know my relation see if the player has any Emoticons which I recognize 
                    Emoticon e = emoticons.getPlayerEmoticon(p);
                    EmoticonType t = e.getCenterEmoticon();                

                    if(t == inLove) {
                        // the single exception that I call stopSteerings here
                        stopSteerings();
                        change = setBehaviour(Behaviour.InLove);
                        // we fell in Love as a second person -> we lead(the other is following us)
                        loveLeader = true;
                    } 
                    else if(t == afraid)
                        change = setBehaviour(Behaviour.Aggresive);
                    else if(t == aggresive)
                        change = setBehaviour(Behaviour.Afraid);                                            
                    else {                    
                        // we do not know the smily, so we choose our randomly
                        if(random.nextBoolean()) {
                            change = setBehaviour(Behaviour.InLove);
                        } else {
                            // negativ relations                    
                            if(random.nextBoolean())  
                                change = setBehaviour(Behaviour.Afraid);
                            else 
                                change = setBehaviour(Behaviour.Aggresive);                                      
                        }                    
                    }                                                            
                }   // end is first meeting (InLove, Aggresive, Afraid)
            }
            
            // we see somebody but we can not talk to him
            if( this.info.getDistance(p.getLocation()) > farRange ) {            
                change = setBehaviour(Behaviour.SpotAPerson);
            }
        } // end if(we see somebody) .. if(p != null)
        
        // we do not see any player
        if(p == null) {
            // and we are at the meeting point
            if(info.getDistance(target) < closeRange) {
                change = setBehaviour(Behaviour.TurningAround);
            } else {
                // lets go alone to meeting point
                change = setBehaviour(Behaviour.GoToMeeting);
            }
        }
        
                
        
        // BEHAVIOURS        
        if(change) {                        
            currentEmo = null;
            if(behaviour != Behaviour.InLove) {
                stopSteerings();            
            }
        }
        
        if(behaviour == Behaviour.GoToMeeting) {
            if(change) {
                anim = AnimType.WALK_DEPRESSED;
                msg = "I am going to the meeting point";
                go2MeetingPoint();
            }
        }
        if(behaviour == Behaviour.SpotAPerson) {                        
            // run only after change between behaviors
            if(change) {                                
                msg = "Wait for me!";                        
                anim = AnimType.WALK_HAPPY;                             
            } 
            // run every turn                         
            followPlayer(p);                                                                                    
        } 
        
        if(behaviour == Behaviour.TurningAround) {
            if(change) {
                anim = AnimType.AMBI_LOOKAROUND01;
                msg = "I am at the meeting point.. the rest as usual is late:)";                
            }
            turnAround();
        }

        // if the Player is close I can express my fealings        
        
        if(behaviour == Behaviour.Afraid) {                                   
            if(change) {                    
                runAwayFromPeople();
                msg = "Ouch, ...don't get close to me, please!";
                currentEmo = new Emoticon(afraid, EmoticonBubbleType.BUBBLE_EMOTIVE_CENTER);
                anim = AnimType.WALK_NORMAL;
            }
            this.move.turnTo(p);            
        }
        
        if(behaviour == Behaviour.Aggresive) {
            if(change) {
                msg = "You? Piss of! Or I will beat you up!";
                currentEmo = new Emoticon(aggresive, EmoticonBubbleType.BUBBLE_EMOTIVE_CENTER);
                anim = AnimType.AMBI_STAND_ANGRY01;
            }
            this.move.turnTo(p);            
        }
                
                                                                
        if(behaviour == Behaviour.InLove) {            
            if(change) {
                currentEmo = new Emoticon(inLove, EmoticonBubbleType.BUBBLE_EMOTIVE_CENTER);
                if(!loveLeader) {
                    followPlayer(p);
                    msg = "Hi! It's nice weather, would you like to hava a walk?";                        
                    anim = AnimType.WALK_ENTHUSE01;
                }
                else  {                    
                    lead2Cinema();
                    msg = "Hi! Sure.. it so nice... Let's go to cinema";
                    anim = AnimType.WALK_SEXY;
                }             
            }
        }                                        
                                                
        if(change) {
            // set the bubble        
            getAct().act(new SendMessage().setGlobal(true).setText(msg));
            // play the animation
            if(animations.getCurrentPlayedAnimation() != anim ) animations.playAnimation(anim,true);        
        }                
        if(currentEmo!=null) {
            emoticons.setEmoticon(currentEmo,1);
        } else {
            emoticons.clearEmoticons();
        }
        
        if(behaviour == Behaviour.InLove && info.getDistance(cinema) < closeRange) {
            // play the experiment from the beginning
            stopSteerings();
            bot.respawn();
        }
    } // end of Logic
    
    void lead2Cinema() {        
        if(!steering.isPathFollowingActive()) {                                                         
            IPathFuture path = pathPlanner.computePath(info.getLocation(), cinema);
            PathFollowingProperties prop = new PathFollowingProperties(SteeringProperties.BehaviorType.ADVANCED);
            prop.setPath(path);
            steering.addPathFollowingSteering(prop);                        
            steering.addObstacleAvoidanceSteering(new ObstacleAvoidanceProperties(SteeringProperties.BehaviorType.ADVANCED));      
        }        
    }    
    
    void runAwayFromPeople(){
        if(!steering.isPeopleAvoidanceActive()){
            PeopleAvoidanceProperties prop = new PeopleAvoidanceProperties(SteeringProperties.BehaviorType.ADVANCED);
            prop.setDistanceFromOtherPeople(closeRange);
            steering.addPeopleAvoidanceSteering(prop);
            steering.addObstacleAvoidanceSteering(new ObstacleAvoidanceProperties(SteeringProperties.BehaviorType.ADVANCED));      
        }    
    }
    
    void stopSteerings(){
//        steering.clearAllSteerings(); // throws an exception
        if(steering.isObstacleAvoidanceActive()) steering.removeObstacleAvoidanceSteering();
        if(steering.isPeopleAvoidanceActive()) steering.removePeopleAvoidanceSteering();
        if(steering.isPathFollowingActive()) steering.removePathFollowingSteering();
        if(steering.isWalkAlongActive()) steering.removeWalkAlongSteering();
        if(steering.isPathFollowingActive()) steering.removePathFollowingSteering();        
        if(steering.isLeaderFollowingActive()) steering.removeLeaderFollowingSteering();                                
    }
        
    void turnAround() {
        int degrees = 50+random.nextInt(50);                    
        if(random.nextDouble()<0.2) {
            if(random.nextBoolean()) {
                degrees = -degrees;
            }
            move.turnHorizontal(degrees);                             
        }
    }
    
    void go2MeetingPoint() {
        if(!steering.isPathFollowingActive()) {                                                         
            IPathFuture path = pathPlanner.computePath(info.getLocation(), target);
            PathFollowingProperties prop = new PathFollowingProperties(SteeringProperties.BehaviorType.ADVANCED);
            prop.setPath(path);
            steering.addPathFollowingSteering(prop);                        
            steering.addObstacleAvoidanceSteering(new ObstacleAvoidanceProperties(SteeringProperties.BehaviorType.ADVANCED));      
        }
    }
    
    void followPlayer(Player p){        
        // p != null
        move.turnTo(p);
                
        if(!steering.isLeaderFollowingActive()){                                                            
            LeaderFollowingProperties prop = new LeaderFollowingProperties(SteeringProperties.BehaviorType.ADVANCED);            
            prop.setLeaderName(p.getName());            
            prop.setDistanceFromTheLeader(100);            
            prop.setLeaderForce(10000000);                        
            steering.addLeaderFollowingSteering(prop);                        
            steering.addObstacleAvoidanceSteering(new ObstacleAvoidanceProperties(SteeringProperties.BehaviorType.ADVANCED));      
        }                
    }
    
    
    /**
     * Called each time the bot dies. Good for reseting all bot's state dependent variables.
     *
     * @param event
     */
    @Override
    public void botKilled(BotKilled event) {
    	// First, try to run the bot and kill it... than uncomment this line and run the bot again
    	// kill it and see the difference.
        //body.getCommunication().sendGlobalTextMessage("I was KILLED!");
        stopSteerings();
        steering.stopNavigation();
    }

    /**
     * This method is called when the bot is started either from IDE or from command line.
     *
     * @param args
     */
    public static void main(String args[]) throws PogamutException {    	
        new UT2004BotRunner<UT2004Bot, UT2004BotParameters>(EmoticonBot.class, "Emohawk-Bot").setPort(3000).setMain(true).setLogLevel(Level.WARNING).startAgents(
            new UT2004BotParameters().setAgentId(new AgentId("One"))
                , new UT2004BotParameters().setAgentId(new AgentId("Two")) 
        );
    }
}
